** sample.prg
** CLIP/db-BRIDGE <-> ORACLE 6.x
** compiled with clipper 5.01, linked ** with BLINKER 1.50
**************Initialize clip/db-Bridge
* the following 2 variables are required
* by the Clip-db-Bridge
PUBLIC gOaryelidx, gOexsqlstr
PUBLIC mSQL_CD
DECLARE ename[10],sal[10]
AFILL(ename," ")
AFILL(sal,0)

mLOWER_RANGE=1
mUPPER_RANGE=10
mJOB="SALESMAN"   && SQL bind variable
**************************************
CLEAR

* login into database
*********************
IF .NOT. ora_login("system/manager")
   ora_exit()
ELSE
   ? 'logged in successfully'
ENDIF
*******************************
* issue select statement
* results placed in cursor and fetched into arrays
*******************************
IF .NOT. ora_select("SELECT ename,sal FROM emp WHERE job=':mJOB'")
    ora_exit()
ELSE
   ? '   Name   Salary'
   * display arrays
   ora_display()
ENDIF
*********************************
* update salary fields
*********************************
IF .NOT. ora_update("UPDATE emp SET sal=1125 WHERE job=':mJOB'")
   ora_exit()
ELSE
   ? 'UPDATE processed successfully'
ENDIF
********************************
* re-issue select statement
* results placed in cursor and fetched * into arrays
********************************
IF .NOT. ora_select("SELECT ename,sal FROM emp WHERE job = ':mJOB'")
   ora_exit()
ELSE
   ? '  Name   Salary'
   * display arrays
   ora_diplay ()
ENDIF
*****************************
* logoff from database
* cancel changes
*****************************
@SOURCE = ora_exit('rollback')

RETURN
*****************************
FUNCTION ora_display
* determine # of rows in cursor
mROWs_FETCHED=d_rowsftch()
* loop to display values in cursor
DO WHILE (mROWS_FETCHED>>0)
*****************************
* display range of values in cursor
*      range dictated by d_setlohi()
*****************************
   FOR i = 1 TO mROWS FETCHED
      ? ename[i]+'  '+STR(sal[i])
NEXT
***************************
* error testing
*   if end of cursor (1403) exit display * loop
*   if other error exit ORACLE
***************************
   IF mSQL_CD <> 0
      IF mSQL_CD = 1403
         ? '      End of result set reached'
         EXIT
      ELSE
         ora_error(d_oraerrcd(),d_oraerrms())
         ora_exit()
      ENDIF
   ENDIF
******************************
* arrays have been displayed and there are still
* rows in cursor; fetch another set of rows
******************************
   IF .NOT. ora_fetch()
      ora_exit()
   ENDIF
mROWS_FETCHED=d_rowsftch()
ENDDO
RETURN 0

FUNCTION ora_error
* display an error message
PARAMETERS mERRCDE,mERRMSG
? STR(mERRCDE)+' '+mERRMSG
WAIT
RETURN 0

FUNCTION ora_exit
* exit oracle and application
* supply 'rollback' parameter to
*   cancel changes
PARAMETER mSTATE
IF mSTATE='rollback'
   d_rollback(0)
ENDIF
d_logoff()
QUIT
RETURN O

FUNCTION ora_fetch
* read cursor into arrays
* returns: .t. if successful, .f. if not
mRC=d_fetch(0)  && static cursor
IF mRC <> 0
   IF mRC <> 1403
    ora_error(d_oraerrcd(),d_oraerrms())
    ENDIF
ENDIF
RETURN IIF((mRC=0 .OR. RC=1403),.t.,.f.)

FUNCTION ora_login
* access RDBMS engine
* returns: .t. if successful, .f. if not
PARAMETERS mUIDPW
mRC=d_connect(mUIDPW)
IF mRC <> 0
   ora_error(mRC,d_oraerrms())
ENDIF
RETURN IIF(mRC=0,.t.,.f.)

FUNCTION ora_select
PARAMETERS mSQL_STAT
* submit SELECT statement
* returns: .t. if 0 or end-of-fetch)
*          .f. otherwise
* specify range of arrays to populate
mRC=d_setlohi(0,mLOWER_RANGE,mUPPER_RANGE)
mRC=d_sql(0,mSQL_STAT)
IF mRC <> 0 .AND. mRC <> 1403
   ora_error(mRC,d_oraerrms())
ELSE
   mSQL_CD=mRC
ENDIF
RETURN IIF((mRC=O .OR. RC=1403),.t.,.f.)

FUNCTION ora_update
* submit SQL statement
* returns: .t. if successful, .f. if not PARAMETERS mSQL_STAT
mRC=d_sql(0,mSQL_STAT)
IF mRC <> 0
   ora_error(d_oraerrcd(),d_oraerrms())
ENDIF
RETURN IIF(mRC=0,.t.,.f.)

*End of sample.prg

