// Test11.prg
// Hilights entire row ...

// Program sequence illustrating how to browse a record
// on more than one line

// Number of address lines
#define NUM_ADDR_LINES 3

#include "inkey.ch"

FUNCTION devtes11

FIELD lname, fname, addr1, addr2, addr3, hphone, wphone IN names

LOCAL to
LOCAL nAddrLine := 1      // Address line # we are looking at
LOCAL nKey
LOCAL lExitRequested
LOCAL i
LOCAL nVisRows

    USE names
    IF !file("names.ntx")
        INDEX ON upper(lname) TO names
    ELSE
        SET INDEX TO names
    ENDIF

    CLEAR SCREEN
    @ 0, 0 TO 23, 79

//    to := tbrowseNew(1, 1, 22, 78)
    to := tbrowseNew(1, 1, 21, 78)

    to:addColumn(tbColumnNew("Last Name",  ;
                             {|| iif(nAddrLine == 1, lname, "")} ))

    to:addColumn(tbColumnNew("First Name", ;
                             {|| iif(nAddrLine == 1, fname, "")} ))

    to:addColumn(tbColumnNew("Home Phone", ;
                             {|| iif(nAddrLine == 1, hphone, "")} ))

    to:addColumn(tbColumnNew("Work Phone", ;
                             {|| iif(nAddrLine == 1, wphone, "")} ))


    to:addColumn(tbColumnNew("Address", {|| iif(nAddrLine == 1, ;
                                        addr1, ;
                                        iif(nAddrLine == 2, ;
                                            addr2, ;
                                            addr3)) } ))

    to:goTopBlock    := {| | dbGoTop(), nAddrLine := 1  }
    to:goBottomBlock := {| | dbGoBottom(), nAddrLine := NUM_ADDR_LINES }
    to:skipBlock     := {|n| goNext(n, @nAddrLine) }

    lExitRequested := .F.
    DO WHILE !lExitRequested

      dispBegin()
      DO WHILE !to:stabilize()
      ENDDO

      // Make sure we're on line one
      DO WHILE nAddrLine != 1
        to:up()
        DO WHILE !to:stabilize()
        ENDDO
      ENDDO

      // This makes sure we always stay on line 1 of
      // a multi-line browse, and the entire record is always displayed
      // Figure out how many visible rows ... may be at bottom of
      // display
      nVisRows := min(to:rowCount - to:rowPos + 1, NUM_ADDR_LINES)
      IF nVisRows < NUM_ADDR_LINES
        DO WHILE nAddrLine != NUM_ADDR_LINES
          to:down()
          DO WHILE !to:stabilize()
          ENDDO
        ENDDO

        // Now back to line 1
        DO WHILE nAddrLine != 1
          to:up()
          DO WHILE !to:stabilize()
          ENDDO
        ENDDO

      ENDIF

      // The following hilights entire row, including blank lines

      to:colorRect({ to:rowPos, to:leftVisible, ;
                     to:rowPos + NUM_ADDR_LINES - 1, to:rightVisible }, ;
                     {2, 1})
/*
      // This version just highlights non-blank lines
      FOR i := to:leftVisible TO to:rightVisible
        IF !(to:getColumn(i):heading = "Address")
          to:colorRect( {to:rowPos, i, to:rowPos, i}, {2, 1})
        ELSE
          to:colorRect( {to:rowPos, i, to:rowPos + NUM_ADDR_LINES - 1, i}, ;
                        {2, 1})
        ENDIF
      NEXT
*/
      dispEnd()

      nKey := inkey(0)

      // dehighlight non empty rows
/*
      FOR i := to:leftVisible TO to:rightVisible
        IF !(to:getColumn(i):heading = "Address")
          to:colorRect( {to:rowPos, i, to:rowPos, i}, {1, 2})
        ELSE
          to:colorRect( {to:rowPos, i, to:rowPos + NUM_ADDR_LINES - 1, i}, ;
                       {1, 2})
        ENDIF
      NEXT
*/

      // dehilite entire row before continuing
      to:colorRect({ to:rowPos, to:leftVisible, ;
                     to:rowPos + NUM_ADDR_LINES - 1, to:rightVisible }, ;
                     {1, 2})

      // This makes sure we always move to next record, not
      // necessarily next line
      IF nKey == K_DOWN
        FOR i := 1 TO NUM_ADDR_LINES
          to:down()
        NEXT
      ELSEIF !stdMeth(nKey, to)
        DO CASE
          CASE nKey == K_ESC
            lExitRequested := .T.
        ENDCASE
      ENDIF
    ENDDO

    CLEAR SCREEN

RETURN NIL


FUNCTION goNext(nToSkip, nAddrLine)

FIELD addr1, addr2, addr3 IN names

LOCAL nSkipped := 0, ;
      nDirection := iif(nToSkip > 0, 1, -1)

    DO WHILE nSkipped != nToSkip .AND. !eof() .AND. !bof()
        IF nDirection >= 1
          IF nAddrLine == NUM_ADDR_LINES
            nAddrLine := 1
            SKIP
          ELSE
            nAddrLine++
          ENDIF
        ELSE
          IF nAddrLine == 1
            nAddrLine := NUM_ADDR_LINES
            SKIP -1
          ELSE
            nAddrLine--
          ENDIF
        ENDIF
        nSkipped += nDirection
    ENDDO

    IF bof()
        nSkipped++
        GOTO recno()       // Just to reset bof()
        nAddrLine := 1
    ELSEIF eof()
        SKIP -1
        nSkipped--
        nAddrLine := NUM_ADDR_LINES
    ENDIF

RETURN nSkipped
