// Test12.prg
// Hilights entire row ...

// Program sequence illustrating how to browse a record
// on more than one line. generic version where you browse an array
// of blocks

#include "inkey.ch"

FUNCTION devtes12

FIELD lname, fname, addr1, addr2, addr3, hphone, wphone IN names

LOCAL to
LOCAL nAddrLine := 1
LOCAL nKey
LOCAL lExitRequested
LOCAL i
LOCAL nVisRows
LOCAL nLinesRec
LOCAL aFields := { ;
                   {|| lname }, ;
                   {|| fname }, ;
                   {|| addr1 }, ;
                   {|| addr2 }, ;
                   {|| addr3 }  ;
                 }

    nLinesRec := len(aFields)

    USE names
    IF !file("names.ntx")
        INDEX ON upper(lname) TO names
    ELSE
        SET INDEX TO names
    ENDIF

    CLEAR SCREEN
    @ 0, 0 TO 23, 79

    to := tbrowseNew(1, 1, 21, 78)

    to:addColumn(tbColumnNew("Names",  ;
                             {|| eval(aFields[nAddrLine]) } ))

    to:goTopBlock    := {| | dbGoTop(), nAddrLine := 1  }
    to:goBottomBlock := {| | dbGoBottom(), nAddrLine := nLinesRec }
    to:skipBlock     := {|n| goNext(n, @nAddrLine, nLinesRec) }

    lExitRequested := .F.
    DO WHILE !lExitRequested

      dispBegin()
      DO WHILE !to:stabilize()
      ENDDO

      // Make sure we're on line one
      DO WHILE nAddrLine != 1
        to:up()
        DO WHILE !to:stabilize()
        ENDDO
      ENDDO

      // This makes sure we always stay on line 1 of
      // a multi-line browse, and the entire record is always displayed
      // Figure out how many visible rows ... may be at bottom of
      // display
      nVisRows := min(to:rowCount - to:rowPos + 1, nLinesRec )
      IF nVisRows < nLinesRec
        DO WHILE nAddrLine != nLinesRec
          to:down()
          DO WHILE !to:stabilize()
          ENDDO
        ENDDO

        // Now back to line 1
        DO WHILE nAddrLine != 1
          to:up()
          DO WHILE !to:stabilize()
          ENDDO
        ENDDO

      ENDIF

      // The following hilights entire row, including blank lines

      to:colorRect({ to:rowPos, to:leftVisible, ;
                     to:rowPos + nLinesRec - 1, to:rightVisible }, ;
                     {2, 1})
      dispEnd()

      nKey := inkey(0)

      // dehilite entire row before continuing
      to:colorRect({ to:rowPos, to:leftVisible, ;
                     to:rowPos + nLinesRec - 1, to:rightVisible }, ;
                     {1, 2})

      // This makes sure we always move to next record, not
      // necessarily next line
      IF nKey == K_DOWN
        FOR i := 1 TO nLinesRec
          to:down()
        NEXT
      ELSEIF !stdMeth(nKey, to)
        DO CASE
          CASE nKey == K_ESC
            lExitRequested := .T.
        ENDCASE
      ENDIF
    ENDDO

    CLEAR SCREEN

RETURN NIL


FUNCTION goNext(nToSkip, nAddrLine, nLinesrec)

FIELD addr1, addr2, addr3 IN names

LOCAL nSkipped := 0, ;
      nDirection := iif(nToSkip > 0, 1, -1)

    DO WHILE nSkipped != nToSkip .AND. !eof() .AND. !bof()
        IF nDirection >= 1
          IF nAddrLine == nLinesRec
            nAddrLine := 1
            SKIP
          ELSE
            nAddrLine++
          ENDIF
        ELSE
          IF nAddrLine == 1
            nAddrLine := nLinesRec
            SKIP -1
          ELSE
            nAddrLine--
          ENDIF
        ENDIF
        nSkipped += nDirection
    ENDDO

    IF bof()
        nSkipped++
        GOTO recno()       // Just to reset bof()
        nAddrLine := 1
    ELSEIF eof()
        SKIP -1
        nSkipped--
        nAddrLine := nLinesRec
    ENDIF

RETURN nSkipped














